LeetCode

来源:互联网 发布:资源分配算法 编辑:程序博客网 时间:2024/06/07 00:00

746. Min Cost Climbing Stairs My SubmissionsBack to Contest

On a staircase, the i-th step has some non-negative cost cost[i] assigned (0 indexed).

Once you pay the cost, you can either climb one or two steps. You need to find minimum cost to reach the top of the floor, and you can either start from the step with index 0, or the step with index 1.

Example 1:

Input: cost = [10, 15, 20]

Output: 15

Explanation: Cheapest is start on cost[1], pay that cost and go to the top.

Example 2:

Input: cost = [1, 100, 1, 1, 1, 100, 1, 1, 100, 1]

Output: 6

Explanation: Cheapest is start on cost[0], and only step on 1s, skipping cost[3].

Note:

cost will have a length in the range [2, 1000].
Every cost[i] will be an integer in the range [0, 999].

题意: 给你一些数,代表走每阶楼梯的代价,你可以一次走一步或两步,问你走到楼顶,最少的消耗代价

分析: 转移方程dp[i] 代表走到第i阶楼梯所需的最小代价,因为你得走到楼顶,所以得虚加一个“楼顶”,代价为零,转移方程为:dp[i]=min(dp[i1]+cost[i],dp[i1]+cost[i])

参考函数

class Solution {public:    int dp[1010];    int minCostClimbingStairs(vector<int>& cost) {        if(cost.size() == 0) return 0;        cost.push_back(0);        dp[0] = cost[0];        dp[1] = cost[1];        for(int i = 2;i <= cost.size();i++) {            dp[i] = min(dp[i-1] + cost[i],dp[i-2]+cost[i]);        }        return dp[cost.size()];    }};
  • 如有错误或遗漏,请私聊下UP,thx